local T, C, L = unpack(Tukui) -- Import: T - functions, constants, variables; C - config; L - locales
--------------------------------------------------------------------
 -- experience
--------------------------------------------------------------------
if C["datatext"].exp and C["datatext"].exp > 0 then
	local Stat = CreateFrame("Frame", "TukuiStatExperience")
	Stat:EnableMouse(true)
	Stat:SetFrameStrata("BACKGROUND")
	Stat:SetFrameLevel(3)
	Stat.Option = C.datatext.exp
	Stat.Color1 = T.RGBToHex(unpack(C.media.datatextcolor1))
	Stat.Color2 = T.RGBToHex(unpack(C.media.datatextcolor2))
	
	local maxlvl = UnitLevel("player") == MAX_PLAYER_LEVEL
	
	local Text  = Stat:CreateFontString("TukuiStatExperienceText", "OVERLAY")
	Text:SetFont(C.media.font, C["datatext"].fontsize)
	T.PP(C["datatext"].exp, Text)

	local function OnEvent(self, event, ...)
		maxlvl = UnitLevel("player") == MAX_PLAYER_LEVEL
		
		if not maxlvl then
			local currentXP, maxXP, restXP = UnitXP("player"), UnitXPMax("player"), GetXPExhaustion()
			local percentXP = T.Round((currentXP/maxXP)*100, 1)

			Text:SetFormattedText('%s%%', percentXP)
		elseif GetWatchedFactionInfo() then
			local name, rank, minRep, maxRep, value = GetWatchedFactionInfo()
			local percentRep = T.Round(value/(maxRep)*100, 1)
			Text:SetFormattedText('%s%%', percentRep)
		else
			Text:SetText("-")
		end
		
		self:SetAllPoints(Text)
	end
	
	local function OnEnter(self)
		if not InCombatLockdown() then
			if maxlvl and not GetWatchedFactionInfo() then return end
			
			local anchor, panel, xoff, yoff = T.DataTextTooltipAnchor(Text)
			GameTooltip:SetOwner(panel, anchor, xoff, yoff)
			GameTooltip:ClearLines()
			
			if not maxlvl then
				local currentXP, maxXP, restXP = UnitXP("player"), UnitXPMax("player"), GetXPExhaustion()
				local percentRestXP = GetXPExhaustion() and T.Round((GetXPExhaustion()/maxXP)*100, 1)
				local percentXP = T.Round((currentXP/maxXP)*100, 1)
				
				GameTooltip:AddDoubleLine("Current XP", currentXP)
				GameTooltip:AddDoubleLine("Max XP", maxXP)
				if restXP then GameTooltip:AddDoubleLine("Rested", "|cff3399ff"..restXP.."|r") end
			end
			
			if GetWatchedFactionInfo() then
				if maxlvl then GameTooltip:AddLine("") end
				local name, rank, minRep, maxRep, value = GetWatchedFactionInfo()
				local percentRep = T.Round(value/(maxRep)*100, 1)
				Text:SetFormattedText('%s%s%%|r', Stat.Color2, percentRep)
			end
			
			
			GameTooltip:Show()
		end
	end
	
	local function OnLeave(self) GameTooltip:Hide() end
          
	local events = { "PLAYER_ENTERING_WORLD","PLAYER_LEVEL_UP","PLAYER_XP_UPDATE","UPDATE_EXHAUSTION","UPDATE_FACTION","PLAYER_ENTERING_WORLD", "DISABLE_XP_GAIN", "ENABLE_XP_GAIN" }
	for _,e in pairs(events) do
		Stat:RegisterEvent(e)
	end
	Stat:SetScript("OnEvent", OnEvent)
	Stat:SetScript("OnEnter", OnEnter)
	Stat:SetScript("OnLeave", OnLeave)
end